
/*]  Copyright (c) 2009-2010, Charles McGarvey  [**************************
**]  All rights reserved.
*
* vi:ts=4 sw=4 tw=75
*
* Distributable under the terms and conditions of the 2-clause BSD license;
* see the file COPYING for a complete text of the license.
*
**************************************************************************/

#ifndef _HEROINE_HH_
#define _HEROINE_HH_

#include <boost/shared_ptr.hpp>

#include <moof/event.hh>

#include "Character.hh"


class Heroine;
typedef boost::shared_ptr<Heroine> HeroineP;


/**
 * The protagonist.
 */

class Heroine : public Character
{
public:

	Heroine();

	static HeroineP alloc()
	{
		return HeroineP(new Heroine);
	}

	void update(moof::scalar t, moof::scalar dt);
	bool handle_event(const moof::event& event);
};


#endif // _HEROINE_HH_

